/*
 * Christophe Lucas <clucas@rotomalug.org>
 *
 * Setup Intel 8259 PIC
 */

#include <video/bochs.h>
#include <video/x86_video.h>
#include <testos/types.h>
#include <testos/ioports.h>
#include <testos/errno.h>

int processor_identification()
{
	ui32_t eflags;
	ui32_t test;
	ui32_t processor;

	asm (
		"pushf		\n\
		 popl %0"
		:"=g"(eflags)
	);

	bochs_printf("eflags=%x\n", eflags);
	bochs_printf("eflafs>>21=%x\n",eflags>>21);
	test = eflags >> 21 ;
	if ((test & 1UL) == 0) {
		bochs_printf("Processor too old, ID flags is not set!\n"
			     "We are not using CPUID.\n");
		return -1;
	}

	asm (
	     "movl $0, %%eax	\n\
	      cpuid		\n\
	      movl %%eax, %0"
	      : "=m"(processor)
	);

	bochs_printf("processor type=%x\n",processor);
	return 0;
}

