#ifndef __ASSERT_H__
#define __ASSERT_H__


void display_fatal_error(const char *format, /* args */...)
     __attribute__ ((format (printf, 1, 2), noreturn));


/**
 * If the expr is FALSE, print a message and halt the machine
 */
#define ASSERT_FATAL(expr) \
   ({ \
     int __res=(int)(expr); \
     if (! __res) \
       display_fatal_error("%s@%s:%d Assertion " # expr " failed", \
			       __PRETTY_FUNCTION__, __FILE__, __LINE__); \
   })


#define FATAL_ERROR(fmt,args...) \
   ({ \
      display_fatal_error("%s@%s:%d FATAL: " fmt, \
			      __PRETTY_FUNCTION__, __FILE__, __LINE__, \
                              ##args); \
   })

#endif
