/*
 * physmem.h
 *
 * 	Christophe Lucas <clucas@rotomalug.org>
 * 	This file is under GPLv2 term
 */

#ifndef __PHYSMEM_H__
#define __PHYSMEM_H__

#include <testos/types.h>
#include <testos/macros.h>
#include <x86/mem.h>

#define MEM_ALIGN_SUP(x)	ALIGN_SUP(x, PAGE_SIZE)
#define MEM_ALIGN_INF(x)	ALIGN_INF(x, PAGE_SIZE)

struct physmem_page {
	paddr_t paddr;
	count_t refcounter;

	struct physmem_page* prev;
	struct physmem_page* next;
};

extern int physmem_init(ui32_t ram_size);
extern void test_physmem_subsystem();
extern ui32_t get_nr_free_pages();
extern ui32_t get_nr_used_pages();
extern paddr_t get_physmem_page();
extern int release_physmem_page(paddr_t paddr);

#endif

