/*
 * pgtable.h
 *
 * Christophe Lucas <clucas@rotomalug.org>
 * This file is under GPL v2.
 */

#ifndef __PGTABLE_H__
#define __PGTABLE_H__

#define NR_PDE	1024
#define NR_PTE	1024

/*
 * Before PAGE_OFFSET: vaddr_t is user virtual address
 * After  PAGE_OFFSET: vaddr_t is kernel virtual address
 */
#define PAGE_OFFSET	0xc0000000

struct pde {
	ui32_t page_dir_base_add:20;
	ui8_t available:3;
	ui8_t global_page:1;
	ui8_t page_size:1; /* 0 : 4Kb */
	ui8_t reserved:1; /* set to 0 */
	ui8_t accessed:1;
	ui8_t pcd:1; /* cache disabled */
	ui8_t pwt:1; /* write throught */
	ui8_t privilege:1; /* User/superuser() */
	ui8_t rw:1;
	ui8_t present:1;
} __attribute__ ((packed, aligned(8)));

struct pte {
	ui32_t page_dir_base_add:20;
	ui8_t available:3;
	ui8_t global_page:1;
	ui8_t page_table_attribute:1; /* */
	ui8_t dirty:1; /* set to 0 */
	ui8_t accessed:1;
	ui8_t pcd:1; /* cache disabled */
	ui8_t pwt:1; /* write throught */
	ui8_t privilege:1; /* User/superuser() */
	ui8_t rw:1;
	ui8_t present:1;
} __attribute__ ((packed, aligned(8)));



#endif
