/* 
 * pgtable.c
 *
 * Christophe Lucas <clucas@rotomalug.org>
 * This fils is under GPL v2 terms.
 */

#include <testos/types.h>
#include <x86/pgtable.h>

static struct pde[NR_PDE];


static void setup_cr0()
{
	/* 
	 * We set PG it in cr0  register:
	 * We enable paging by means of this register bit
	 */
	asm volatile
	(
		"movl %%cr0, %eax	\n\
		 orl %eax, 1<<31	\n\
		 movl %%eax, %cr0
		"
	);
}

void setup_cr3()
{
	asm volatile
	(
	 	"movl %0, %cr3"
	:
	: "m"(pde)
	);
}

int setup_paging()
{
	setup_cr0();
	setup_cr3();
	return OK;
}

int paging_map_paddr_to_vaddr(paddr_t paddr, vaddr_t vaddr)
{
	
	return OK;
}
